// SpawnShell.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SpawnShell.h"

/* Make linker happy without CTR */

extern "C"
{
#pragma function(memset)
	void *memset(void *dest, int c, size_t count)
	{
		char *bytes = (char *)dest;
		while (count--)
		{
			*bytes++ = (char)c;
		}
		return dest;
	}

#pragma function(memcpy)
	void *memcpy(void *dest, const void *src, size_t count)
	{
		char *dest8 = (char *)dest;
		const char *src8 = (const char *)src;
		while (count--)
		{
			*dest8++ = *src8++;
		}
		return dest;
	}
}

#ifdef LOG_TO_FILE

void Log(char * str, DWORD dwErrorCode) {
	size_t dwBytesToWrite = 0;
	StringCbLengthA(str, 4096, &dwBytesToWrite);
	DWORD dwBytesWritten = 0;
	HANDLE hFile;
	hFile = CreateFileW(L"C:\\Temp\\GSS.log", FILE_APPEND_DATA, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return;
	WriteFile(hFile, str, dwBytesToWrite, &dwBytesWritten, NULL);
	WriteFile(hFile, "\r\n", 2, &dwBytesWritten, NULL);
	if (dwErrorCode) {
		LPSTR messageBuffer = nullptr;
		size_t size = FormatMessageA(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, dwErrorCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&messageBuffer, 0, NULL);
		WriteFile(hFile, messageBuffer, size, &dwBytesWritten, NULL);
		WriteFile(hFile, "\r\n", 2, &dwBytesWritten, NULL);
		LocalFree(messageBuffer);
	}
	CloseHandle(hFile);
}

#else

void Log(char * str, DWORD dwErrorCode) {
	OutputDebugStringA(str);
}

#endif

int APIENTRY wWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPWSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
#ifdef LOG_TO_FILE
	Log("Starting", 0);
#endif

	HANDLE hToken;
	if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ALL_ACCESS, &hToken))
	{
		Log("OpenProcessToken failed", GetLastError());
		ExitProcess(1);
	}

	HANDLE hTokenDup;
	if (!DuplicateTokenEx(hToken, TOKEN_ALL_ACCESS, nullptr, SecurityAnonymous, TokenPrimary, &hTokenDup))
	{
		Log("DuplicateTokenEx failed", GetLastError());
		ExitProcess(2);
	}

	DWORD dwSessionId = WTSGetActiveConsoleSessionId();
	if (dwSessionId == 0xFFFFFFFF)
	{
		Log("WTSGetActiveConsoleSessionId failed", GetLastError());
		ExitProcess(3);
	}

	if (!SetTokenInformation(hTokenDup, TokenSessionId, &dwSessionId, sizeof(dwSessionId)))
	{
		Log("SetTokenInformation failed", GetLastError());
		ExitProcess(4);
	}

	PROCESS_INFORMATION pi = {};
	STARTUPINFO si = {};
	si.cb = sizeof(si);
	si.lpDesktop = L"WinSta0\\Default";

	if (!CreateProcessAsUser(hTokenDup, L"C:\\Windows\\System32\\cmd.exe", L"C:\\Windows\\System32\\cmd.exe", NULL, NULL, FALSE, CREATE_NEW_CONSOLE, NULL, NULL, &si, &pi))
	{
		Log("CreateProcessAsUser failed", GetLastError());
		ExitProcess(5);
	}
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

#ifdef LOG_TO_FILE
	Log("Everything OK", 0);
#endif
	
	ExitProcess(0);
}
